/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with main.c; if not, write to:
 *            The Free Software Foundation, Inc.,
 *            59 Temple Place - Suite 330,
 *            Boston,  MA  02111-1307, USA.
 */


//
// Class: suffix_node
// Created by: bountykiller <masse_nicolas@yahoo.fr>
// Created on: Sat Jun 11 00:28:59 2005
//

#ifndef _SUFFIX_NODE_H_
#define _SUFFIX_NODE_H_

#include "suffix_tree.h"

namespace cpl
{
namespace internals
{

template <typename T> 
class SuffixNode : protected SuffixTree<T>
{
	public:
		SuffixNode(const char *key);
		SuffixNode(const char *key, SuffixTree<T> &root);
		virtual ~SuffixNode();
		char first(); 
		bool key_exist(const char *key); 
		SuffixNode<T>& insert(T& data, const char key[]);
		//SuffixNode& insert(int data, const char *key);
		void print_tree();
			
	protected:
		char *localKey;
		bool isKey;
		SuffixTree<T>* parent;
		list<T> datas;
		SuffixNode<T>& split(int i);
};

}
}//namespaces

#endif	//_SUFFIX_NODE_H_

