// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <iostream>
#include "suffix_tree.h"
#include "suffix_node.h"
#include "debug.h"

#define N_C_KEYWORDS 24

const static char* C_Keywords[N_C_KEYWORDS] = {"void","char","short","int",
"long","float","double","signed","unsigned","typedef","extern",
"static","auto","register","const","volatile","enum","if",
"else","do","while","for","return","sizeof"};


using namespace cpl::internals;
using namespace std;

template class SuffixTree<int>;
template class SuffixNode<int>;

int main(int argc, char **argv)
{
	ASSERT(argc > 1);
	SuffixTree<int> *root;
	cout << "C'est parti ;) \n";
	root = new SuffixTree<int>();
	for(int i=0; i < N_C_KEYWORDS; ++i)
	{
		root->insert(i, C_Keywords[i]);
		root->print_tree();
	}
	
	
	cout << "teste la(es) clef(s)\n";
	for(int i=1; i < argc; ++i)
	{
		if ( !(root->key_exist(argv[i])) )
			cout << "Cle " << argv[i] << " non trouvee!!\n";
		else
			cout << "Cle " << argv[i] << " trouvee ;) \n";
	}
	root->print_tree();
	
}

 
